function [ximin11, ximin51, Measures] = runallpso(loaddata)
%% Runs pso for all 12 cases of Table 3; prepares output and stores in 'table3.mat'
% Example:  [ximin11, ximin51, Measures] = runallpso(1) to use the stored data
close all
rng(99)
ximin11 = zeros(11,6);
ximin51 = zeros(51,6);
NN = [11;11;51;51];
nunu = [.5;1;.5;1];
Measures = zeros(12,5);

for degree = 1:3
    if(degree == 1)
        n = 10;
    elseif(degree == 2)
        n = 15;
    elseif(degree == 3)
        n = 20;
    end
    if(~loaddata)
        for j = 1:4
            parameters = [NN(j), n, nunu(j), degree]
            if(j==1 || j==2)
                [ximin11(:,2*(degree-1)+j), ~, Measures(4*(degree-1)+j,:)]  = minXi(NN(j), n, nunu(j), degree)
            elseif(j==3 || j==4)
                [ximin51(:,2*(degree-1)+j-2), ~, Measures(4*(degree-1)+j,:)]  = minXi(NN(j), n, nunu(j), degree)
            end
        end
    else
        load('table3.mat','ximin11', 'ximin51', 'Measures')
        figure(degree)

        for i = 1:4
            subplot(2,2,i)
            N = NN(i);
            chi = linspace(-1,1,N)';
            if(i==1 || i==2)
                nximin = n*ximin11(:,2*(degree-1)+i);
            elseif(i==3 || i==4)
                nximin = n*ximin51(:,2*(degree-1)+i-2);
            end
            hold on
            bar(chi, nximin, BarWidth=.1)
            ylim([0, max(nximin)]);
            yticks(1:max(nximin));
            xlabel([' N = ', num2str(N) ,', \nu = ', num2str(nunu(i))]);
            hold off
        end
    end
end

Measures = [[NN;NN;NN],[nunu;nunu;nunu],Measures];

save('table3.mat','ximin11', 'ximin51', 'Measures')